// Test cycles through the RGB LED and Display's on the OLED....Basic uf2 example. for Nrf52840 
//
// setup self Test for Xiao Nrf52840 BLE & Nrf52840 BLE Sense MCU chips. RGB LED.
// Pj Glasso
//
#include <Arduino.h>                  
#include <Wire.h>
#include <U8x8lib.h>      //Display
#include <SPI.h>          //Communication

const int ledPin = LED_BUILTIN;     // pin to use for the LED
int BuzzerPin = A3;                 //A3 , P0.29 PIN 4
int buzzer = BuzzerPin;
U8X8_SSD1306_128X64_NONAME_HW_I2C u8x8(/* clock=*/ PIN_WIRE_SCL, /* data=*/ PIN_WIRE_SDA, /* reset=*/ U8X8_PIN_NONE);
 // OLEDs without Reset of the Display
void setup() {
  Serial.begin(9600);
  delay (2000);
 
  Serial.println(); // only for mbed 2.9.x
  Serial.println("Power ON \n ");  // Let's BEGIN!!
  initdisplay();    // OLED Init Display Show "Power ON "
  delay (2000);
  Serial.println("Xiao RGB LED & OLED Test compiled on " __DATE__ " at " __TIME__);
  Serial.println("Processor came out of reset.");
  Serial.println();
   startsound();
  setupblink();  // RGB LED TEST RED, GREEN, BLUE
}

void loop() {
   // check if time display should be output
 setupblink();
}
 //END

//
// -------------------- Utilities ------------------------- //
//

void setupblink(){
  Serial.print("Testing R G B LED - ");
   u8x8.setCursor(0,3); //POSITION STATUS Word
   u8x8.print("Testing LED ");
   u8x8.clearLine(5);
   u8x8.clearLine(6);
   u8x8.setCursor(5,5); // Position Data float battery
   u8x8.print("R.G.B.LED");
   delay(2000);
   setLedRGB(true, false, false);  // Red
   Serial.print("RED, ");
   u8x8.clearLine(5);
   u8x8.clearLine(6);
   u8x8.setCursor(2,5); // Position Data float battery
   u8x8.print("R E D" );
   delay(2000);
   setLedRGB(false, true, false);  // Gren
   Serial.print("GREEN, ");
   u8x8.setCursor(2,5); // Position Data float battery
   u8x8.print("G R E E N");
   delay(2000);
   u8x8.clearLine(5);
   u8x8.clearLine(6);
   setLedRGB(false, false, true);  // Blue 
   Serial.println("BLUE... "); 
   u8x8.setCursor(2,5); // Position Data float battery
   u8x8.print("B L U E ");
   delay(2000);
   setLedRGB(false, false, false);  // OFF
}

void initdisplay() {
  pinMode(LEDR, OUTPUT);  // initialize the LED pin as an output:
  pinMode(LEDG, OUTPUT);  // initialize the LED pin as an output:
  pinMode(LEDB, OUTPUT);
  pinMode(LED_BUILTIN, OUTPUT);  // initialize the LED pin as an output:
  digitalWrite(LEDR, HIGH);
  digitalWrite(LEDG, HIGH);
  digitalWrite(LEDB, HIGH);
  u8x8.begin();
  u8x8.setFlipMode(0);  // set number from 1 to 3, the screen word will rotary 180
  u8x8.setFont(u8x8_font_8x13B_1x2_r);
  u8x8.clearDisplay();
  u8x8.setCursor(0, 0);
  u8x8.print("Power ON ");
}

void startsound() {
  u8x8.setCursor(0,3); //POSITION STATUS Word
  u8x8.print("ROLL Sound:");
  u8x8.clearLine(5);
  u8x8.clearLine(6);
  u8x8.setCursor(8,5); // Position Data float battery
  delay(500);
  u8x8.print("Start-up");
  Serial.println("Playing startup sound");

  tone (buzzer, 890);
    delay (220);
    noTone(buzzer);
    delay (20);
    tone (buzzer, 800);
    delay (220);
    noTone(buzzer);
    delay (20);
    tone (buzzer, 800);
    delay (220);
    noTone(buzzer);
    delay (20);
    tone (buzzer, 990);
    delay (420);
    noTone(buzzer);
    delay (20);
}

void setLedRGB(bool red, bool green, bool blue) {
   if (!red) { digitalWrite(LEDR, HIGH); } else { digitalWrite(LEDR, LOW); }
   if (!green) { digitalWrite(LEDG, HIGH); } else { digitalWrite(LEDG, LOW); }
    if (!blue) { digitalWrite(LEDB, HIGH); } else { digitalWrite(LEDB, LOW); }
}